#include <iostream>

#include "regression.hpp"
#include "regularisation.hpp"
#include "matrice.hpp"
#include <random>

default_random_engine re2(time(0));
uniform_real_distribution<double> distrib2(0,1.0);

double func(int d, valarray<double> x){
   double res=0.0;
   for (int i=0;i<d;i++){
      res = res + 0.2*x[i]*x[0];
   }
   res = res -x[d-1]*x[d-1];
   return res;
}

double gaussian(int d, valarray<double> xi , valarray<double> xj){
   double res=0.0;
   valarray<double> prod;
   prod = xi*xj;
   res = prod.sum();
   cout<<" inside "<<xi[0]<<" "<<xj[0]<<" "<<res<<endl;
   res = exp(res/200);
   cout<<"sjdbjbdfjb "<<res<<endl;
   return res;
}


int main() {
   int d= 30;
   int n=20;
   double h=1.0/20;

   vector< valarray<double> > x(n);
   vector< double> y(n);

   for (int i=0;i<n;i++){
      x[i].resize(d);
      for (int j=0;j<d;j++){
         x[i][j]=distrib2(re2);
      }
      y[i]=func(d,x[i]);
   }
   cout<<"coucou2"<<endl;
   for (int i=0;i<n;i++){
      for (int j=0;j<n;j++){
         regk.set_A(i,j,x[i],x[j]);
      }
      regk.set_b(i,y[i]);
   }
   cout<<"coucou3"<<endl;


   ridge<double,20> reg(0.1);
   Regression<double,20,30> regk(gaussian,&reg);

   regk.gradient_descente(50,0.0005);
   for (int i=0;i<n;i++){
      cout<<i<<" "<<regk.get_sol(i)<<endl;
   }

   return 0;
}
